﻿
SuperStrict

SeedRnd(MilliSecs())

AppTitle = "tcpClient"

Include "utils.bmx"

Local remotePort:Int = 50000
If(FileType("port.txt") = 1)
	remotePort = Int(LoadText("port.txt"))
EndIf
Local remoteIp:Int = HostIp("127.0.0.1")

Global cliSocket:TSocket = CreateTCPSocket()
ConnectSocket(cliSocket, remoteIp, remotePort)

Global bufSize:Int = 255
Global bufData:Byte[] = New Byte[bufSize]

Global bufStr:String[] = Null

Global listMsg:TList = New TList

Global maxLines:Int = 20

Global screenW:Int = 800
Global screenH:Int = 600

Graphics screenW, screenH
SetImageFont(LoadImageFont("arial.ttf", 16))
   
Global text:String
Global strTmp:String

text = ""

Global ch:Int = 0

Global onConnect:Int = True

Global posX:Float, posY:Float, spdX:Float, spdY:Float
Global timeMoveStart:Int, timeMoveInterval:Int = 100

posX = Rand(screenW)
posY = Rand(screenH)
spdX = Rnd(-1, 1)
spdY = Rnd(-1, 1)

Global timeSendPosStart:Int, timeSendPosInterval:Int = 1000


If(Not(SocketConnected(cliSocket)))
	DrawText "Server is not run. Try to connecting later.", 20, 20
	DrawText "Press any key to exit.", 40, 50
	WaitKey()
	End
EndIf

Local rez:Int = False

Global onRunning:Int = True


While(onRunning = True)
	
	If(KeyHit(KEY_ESCAPE) Or AppTerminate())
		onRunning = False
		Exit
	EndIf
	
	 
	drawMessages()
		
	SetColor 155, 155, 155
	DrawLine 10, 10, screenW - 10, 10
	DrawLine 10, screenH - 50, screenW - 10, screenH - 50
	DrawLine 10, screenH - 10, screenW - 10, screenH - 10
	
	SetColor 255, 255, 255
	DrawText "> " + text, 10, screenH - 40
	
	If(MilliSecs() Mod 1000 < 500)
		DrawRect 10 + TextWidth("> " + text) + 2, screenH - 40, 2, 20
	EndIf
	
	DrawRect(posX, posY, 20, 20)
	 
	Flip()
	Cls()
	
	rez = checkInput()
	
	If(rez = True) 'нажали Enter
		send(text)
		text = ""
	EndIf
	
	recv()
	
	If(Not(SocketConnected(cliSocket)))
		Exit
	EndIf
	
	moveObject()
	
	If(MilliSecs() - timeSendPosStart >= timeSendPosInterval)
		send("POS " + Int(posX) + " " + Int(posY))
		timeSendPosStart = MilliSecs()
	EndIf
	
Wend


CloseSocket(cliSocket)
   
End



Function moveObject()
	If(MilliSecs() - timeMoveStart < timeMoveInterval) Then Return
	
	posX:+spdX * 3
	posY:+spdY * 3
	
	If((posX <= 0 And spdX < 0) Or (posX >= screenW And spdX > 0))
		spdX:*- 1
	EndIf
	If((posY <= 0 And spdY < 0) Or (posY >= screenH And spdY > 0))
		spdY:*- 1
	EndIf
	
	If(Rand(100) < 5)
		spdX = Rnd(-1, 1)
		spdY = Rnd(-1, 1)
	EndIf
	
	timeMoveStart = MilliSecs()
End Function


Function drawMessages(x0:Int = 20, y0:Int = 20)
	
	If(listMsg.IsEmpty()) Then Return
	
	Local px:Int = x0, py:Int = y0
	For Local k:Int = 0 Until listMsg.count()
		px = x0
		strTmp = String(listMsg.ValueAtIndex(k))
		If(Mid(strTmp, 1, 2) = "я:")
			SetColor 255, 255, 0
		ElseIf(Mid(strTmp, 1, 7) = "сервер:")
			SetColor 255, 0, 0
			'px:+5
		Else
			SetColor 255, 255, 255
		EndIf
		DrawText strTmp, px, py
		py:+20
	Next

End Function


Function checkInput:Int()
	ch = GetChar()
	If(ch <> 0)
		text = text + Chr(ch)
		If(ch <> 32) text = text.Trim()
		
		If(ch = 8) 'backspace
			If(Len(text) > 0)
				text = Left(text, Len(text) - 1)
			EndIf
		EndIf
	EndIf
	
	If(ch = 13)
		Return True
	Else
		Return False
	EndIf
End Function


Function send(msg:String)
		
	listMsg.AddLast("я: " + MSG)
	If(listMsg.Count() > maxLines) Then listMsg.Remove(listMsg.First())
	msg:+"~r~n"
	cliSocket.send(msg, Len(msg))
	
End Function


Function recv()
	If(cliSocket.ReadAvail() = 0) Then Return
	
	strTmp = ""
	
	While(cliSocket.ReadAvail() > 0)
		flushBuf(bufData, bufSize)
		cliSocket.Recv(bufData, bufSize)
		strTmp:+String.FromCString(bufData).Trim()
	Wend
	
	strTmp = convertFromAnsi(strTmp)
	
	bufStr = strTmp.Split(Chr(10))
	For Local k:Int = 0 Until bufStr.Length
		If(bufStr[k].Trim() = "") Then Continue
		listMsg.AddLast(bufStr[k].Trim())
		If(listMsg.Count() > maxLines) Then listMsg.Remove(listMsg.First())
	Next

	'разбор команды
	If(strTmp = "ID")
		text = "ID " + String(Rand(1000000))
		send(text)
	Else If(strTmp = "QUIT")
		onRunning = False
	EndIf
	
End Function

