﻿
SuperStrict

Include "utils.bmx"

AppTitle = "tcpServer"



Global maxLines:Int = 20

Global strTmp:String = ""

Global info:String


Graphics 800, 600

SetImageFont(LoadImageFont("arial.ttf", 12))

Local port:Int = 50000
If(FileType("port.txt") = 1)
	port = Int(LoadText("port.txt"))
EndIf

Global server:TServer = New TServer
server.start(port)

Local char:Short


While Not(KeyHit(KEY_ESCAPE) Or AppTerminate())

	server.update()
	
	char = GetChar()
	If(char <> 0) Then server.sendToAll(Chr(char))
	
	DrawText("Port: " + port + ", online: " + server.onlineCount, 20, 50)
	DrawText("Info: " + info, 20, 70)
	
	server.drawPos()
	
	Flip()
	Cls()
	
Wend

server.stop()

End


Function socketSend(sock:TSocket, text:String)
	
	text:+"~r~n"
	sock.Send(text, Len(text))
	DebugLog("send: " + text)
	
End Function


Function socketRecv:String(sock:TSocket, bufData:Byte[], bufSize:Int)
	
	If(sock.ReadAvail() = 0) Then Return Null
	
	strTmp = ""
	Local size:Int = 0
	
	While(sock.ReadAvail() > 0)
		flushBuf(bufData, bufSize)
		size = sock.ReadAvail()
		If(size > bufSize) size = bufSize
		sock.Recv(bufData, size)
		strTmp:+String.FromCString(bufData).Trim()
	Wend
	
	strTmp = convertFromAnsi(strTmp)
		
	Return strTmp
	
End Function



Type TServer
	Field socket:TSocket
	Field connect:TSocket

	Const bufSize:Int = 255
	Field bufData:Byte[] = New Byte[bufSize]
	Field bufStr:String[] = Null

	Field listMsg:TList = New TList

	Field listClients:TList = New TList
	
	Field cmd:String
	
	Field onlineCount:Int
	
	
	
	'запуск
	Method start(port:Int = 5000)
		socket = CreateTCPSocket()
		BindSocket(socket, port)
		SocketListen(socket)
	End Method

	
	'остановка
	Method stop()
		CloseSocket(socket)
	End Method


	'добавление нового клиента в список
	Method clientAdd:TClient(socket:TSocket)
		Local cli:TClient = New TClient
		cli.socket = socket
		listClients.addLast(cli)
		onlineCount:+1
		Return cli
	End Method
	
	
	'удаление клиента из списка
	Method clientRemove(client:TClient)
		listClients.Remove(client)
		onlineCount:-1
		DebugLog("disconnect " + client.getId() + " at " + CurrentTime())
	End Method
	
	
	'обработка клиентов
	Method update()
	
		'подключение новых клиентов
		If(connect = Null)
			connect = SocketAccept(socket)
			If(connect <> Null)
				clientAdd(connect)
				socketSend(connect, "ID")
				connect = Null
			EndIf
		EndIf
		
	
		'прослушивание клиентских сокетов
		If(listClients.IsEmpty()) Return
		
		Local params:String[]
		
		For Local cli:TClient = EachIn listClients
			
			'клиент отключился
			If(cli.socket.Connected() = False)
				clientRemove(cli)
				Continue
			EndIf
			
			'получение и обработка данных
			strTmp = socketRecv(cli.socket, bufData, bufSize)
			If(strTmp <> "")
				bufStr = strTmp.Split("~r~n")
				For Local k:Int = 0 Until bufStr.Length
					cmd = bufStr[k].Trim()
					If(cmd = "") Continue
					'разделение на параметры
					params = commandParseCommand(cli, cmd)
					'выполнение
					commandProcessCommand(cli, params)
					'добавление в чат
					strTmp = cli.getId() + ": " + cmd
					listMsg.AddLast(strTmp)
					If(listMsg.Count() > maxLines) Then listMsg.Remove(listMsg.First())
					DebugLog(strTmp)
				Next
			EndIf
		Next
	
	End Method
	
	
	'разбор команды
	Method commandParseCommand:String[] (client:TClient, cmd:String)
		Local mas:String[] = cmd.Split(" ")
		Return mas
	End Method
	
	
	'выполнение команд
	Method commandProcessCommand(client:TClient, params:String[])
		Local cmd:String = params[0]
		If(cmd = "ID")
			client.setId(Int(params[1]))
		Else If(cmd = "POS")
			client.setPos(Int(params[1]), Int(params[2]))
		Else
			info = cmd
		EndIf
	End Method
	
	
	'массовая рассылка всем, кроме указанного
	Method sendToOther(client:TClient, text:String)
		If(listClients.IsEmpty()) Then Return
	
		For Local cli:TClient = EachIn listClients
			If(cli <> client)
				socketSend(cli.socket, text)
			EndIf
		Next
		
	End Method
	
	'массовая рассылка всем, кроме указанного
	Method sendToAll(text:String)
		sendToOther(Null, text)
	End Method
	
	'рисование позиций на карте
	Method drawPos()
		If(listClients.IsEmpty()) Then Return
		Local px:Int, py:Int, sz:Int = 20
		Local name:String
		
		For Local cli:TClient = EachIn listClients
			px = cli.getX()
			py = cli.getY()
			
			cli.adjustColor()
			DrawRect(px, py, sz, sz)
			
			SetColor(200, 200, 200)
			name = "" + cli.getId()
			DrawText(name, px - (TextWidth(name) - sz) * 0.5, py - 17)
		Next
		
	End Method
	
End Type


Type TClient
	Field socket:TSocket
	Field obj:TObj = New TObj
	
	Field red:Int, green:Int, blue:Int
	
	
	Method setId(id:Int)
		obj.id = id
		red = Rand(100, 255)
		green = Rand(100, 255)
		blue = Rand(100, 255)
	End Method
	
	Method adjustColor()
		SetColor(red, green, blue)
	End Method
	
	Method getId:Int()
		Return obj.id
	End Method
	
	Method setPos(x:Int, y:Int)
		obj.x = x
		obj.y = y
	End Method
	
	Method getX:Int()
		Return obj.x
	End Method
	
	Method getY:Int()
		Return obj.y
	End Method
	
End Type


Type TObj
	Field name:String
	Field id:Int
	Field x:Int, y:Int
End Type
